<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

# express-universal-query-validator

[src/index.js:6-6](https://github.com/wework/express-universal-query-validator/blob/aef89d074551e61867d96a2e66f458b12e6d51dc/src/index.js#L6-L6 "Source code on GitHub")

Express middleware to provide consistently parseable query parameters to universal applications

# defaultRedirect

[src/index.js:29-40](https://github.com/wework/express-universal-query-validator/blob/aef89d074551e61867d96a2e66f458b12e6d51dc/src/index.js#L29-L40 "Source code on GitHub")

Default callback behavior for the middleware
Can be replaced by passing a function argument in the
first position to `queryValidator`. It will receive the
same arguments.

**Parameters**

-   `req` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** 
-   `res` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** 
-   `next` **[Function](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/function)** 
-   `context` **\[[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)](default {})** 
    -   `context.delimiter` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** 
    -   `context.error` **[Error](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Error)** 
    -   `context.oldQuery` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)** 
    -   `context.nextQuery` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)** 
    -   `context.droppedParams` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)** 

Returns **[undefined](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/undefined)** 

# queryValidator

[src/index.js:54-92](https://github.com/wework/express-universal-query-validator/blob/aef89d074551e61867d96a2e66f458b12e6d51dc/src/index.js#L54-L92 "Source code on GitHub")

Create a middleware to validate queries are parseable by both the browser and node.
This should be mounted early.

**Parameters**

-   `cb` **\[[Function](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/function)?](default defaultRedirect)** called to handle invalid params. passed
                            `req`, `res`, `next` and a `context` object
                            containing useful data. The default behavior
                            is to `console.error` and `res.redirect`
-   `options` **\[[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)?](default {})** 
    -   `options.delimiter` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)?** query string delimiter

Returns **[Function](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/function)** middleware - the middleware function to use

# middleware

[src/index.js:63-91](https://github.com/wework/express-universal-query-validator/blob/aef89d074551e61867d96a2e66f458b12e6d51dc/src/index.js#L63-L91 "Source code on GitHub")

**Parameters**

-   `req` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** 
-   `res` **[Response](https://developer.mozilla.org/en-US/docs/Web/Guide/HTML/HTML5)** 
-   `next` **[Function](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/function)** 

Returns **[undefined](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/undefined)** 

# express-universal-query-validator/util

[src/util/index.js:6-6](https://github.com/wework/express-universal-query-validator/blob/aef89d074551e61867d96a2e66f458b12e6d51dc/src/util/index.js#L6-L6 "Source code on GitHub")

Utility functions needed for this module

# isUnparseableQuery

[src/util/index.js:15-17](https://github.com/wework/express-universal-query-validator/blob/aef89d074551e61867d96a2e66f458b12e6d51dc/src/util/index.js#L15-L17 "Source code on GitHub")

Checks if a key=value param can not be
parsed by global `decodeURIComponent`

**Parameters**

-   `query` **\[[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)](default 'key=value')** 

Returns **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** did parsing throw?

# validateQueryParams

[src/util/index.js:24-26](https://github.com/wework/express-universal-query-validator/blob/aef89d074551e61867d96a2e66f458b12e6d51dc/src/util/index.js#L24-L26 "Source code on GitHub")

Are all queries parseable?

**Parameters**

-   `queries` **\[[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)](default \[])** 

Returns **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** 

# dropInvalidQueryParams

[src/util/index.js:33-35](https://github.com/wework/express-universal-query-validator/blob/aef89d074551e61867d96a2e66f458b12e6d51dc/src/util/index.js#L33-L35 "Source code on GitHub")

Returns input minus unparseable queries

**Parameters**

-   `queries` **\[[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)](default \[])** 

Returns **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)** 
